You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

bashrc 17 KiB

13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
12 years ago
11 years ago
11 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
11 years ago
12 years ago
11 years ago
11 years ago
11 years ago
12 years ago
11 years ago
11 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
13 years ago
12 years ago
12 years ago
12 years ago
11 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
12 years ago
11 years ago
11 years ago
11 years ago
11 years ago
12 years ago
123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776
  1. #!/bin/bash
  2. # If not running interactively, don't do anything
  3. [[ $- != *i* ]] && return
  4. ##########################################
  5. null(){
  6. "$@" >/dev/null 2>&1
  7. }
  8. __try_exec(){
  9. type $1 >/dev/null 2>&1 && "$@"
  10. }
  11. ##########################
  12. # system type
  13. alias ismsys=false
  14. alias iscygwin=false
  15. alias iswindows=false
  16. alias isdarwin=false
  17. alias islinux=false
  18. alias with_coreutils=false # for mac
  19. case `uname` in
  20. (MINGW*) alias ismsys=true ;;
  21. (CYGWIN*) alias iscygwin=true ;;
  22. (Darwin*) alias isdarwin=true ;;
  23. (Linux*) alias islinux=true ;;
  24. esac
  25. null ls --version && alias with_coreutils=true
  26. ( ismsys || iscygwin ) && alias iswindows=true
  27. alias inbash=false
  28. alias inzsh=false
  29. if test -n "$BASH_VERSION"
  30. then
  31. alias inbash=true
  32. elif test -n "$ZSH_VERSION"
  33. then
  34. alias inzsh=true
  35. fi
  36. #################################
  37. if echo $PATH | grep "$HOME" >/dev/null 2>&1
  38. then
  39. PATH="${PATH}:${HOME}/.local/bin"
  40. fi
  41. if false iswindows
  42. then
  43. export PAGER='tr -d \\r | less'
  44. else
  45. export PAGER="less"
  46. fi
  47. export LESS="-iRMX"
  48. _src_hilite_lp_path="`which src-hilite-lesspipe.sh 2>/dev/null`"
  49. if test -n "$_src_hilite_lp_path"
  50. then
  51. export LESSOPEN="| $_src_hilite_lp_path %s"
  52. fi
  53. if null type vim
  54. then
  55. export EDITOR=vim
  56. else
  57. export EDITOR=vi
  58. fi
  59. export LANG=ja_JP.UTF-8
  60. export LC_MESSAGES=C
  61. # export CDPATH=".:~"
  62. export VISUAL="$EDITOR"
  63. export GIT_PAGER="less -F"
  64. export GIT_EDITOR="$EDITOR"
  65. if test -n "$TMUX" && \
  66. echo $TERM | grep screen >/dev/null 2>&1 && \
  67. tmux display -p '#{client_termname}' | grep 256color >/dev/null 2>&1
  68. then
  69. TERM=screen-256color
  70. fi
  71. test -z "$TMP" && export TMP=/tmp/${USER}-tmp
  72. mkdir -p "$TMP"
  73. ! iswindows && null type stty && {
  74. stty stop undef # unbind C-s to stop displaying output
  75. # stty erase '^h'
  76. }
  77. if iswindows; then
  78. export USER=$USERNAME
  79. fi
  80. _tmux_prefs(){
  81. null type tmux || return 1
  82. tmux set -g mode-keys vi
  83. }
  84. if test -d ~/dbx
  85. then
  86. export CHIT_PATH="$HOME/dbx/.chit"
  87. fi
  88. #######################
  89. iswindows && alias tty="echo cmd.exe"
  90. type fortune >/dev/null 2>&1 && {
  91. fortune
  92. echo
  93. fortune -o
  94. echo
  95. }
  96. uname -a
  97. echo TERM $TERM $(tput colors) colors connected to $(tty), \
  98. running $BASH $BASH_VERSION
  99. if test -n "$TMUX"
  100. then
  101. tmux display -p 'Using tmux #S:#I:#W.#P, client is #{client_termname}' \
  102. 2>/dev/null
  103. echo
  104. fi
  105. ###################################
  106. # some aliases and functions
  107. ( ! with_coreutils && isdarwin ) || test "$TERM" = dumb || \
  108. _coloroption=" --color=auto"
  109. ( ! with_coreutils && isdarwin ) || iswindows || \
  110. _timeoption=" --time-style=long-iso"
  111. ( ! with_coreutils && isdarwin ) || _hideoption=" --hide=[A-Z]*" # do not use
  112. _timeformat_iso="%Y-%m-%dT%H:%M:%S%z"
  113. _timeformat_rfc2822="%a, %d %b %Y %T %z"
  114. alias ls="ls -hCF${_coloroption}${_timeoption}"
  115. if ! with_coreutils
  116. then
  117. export LSCOLORS=gxfxcxdxbxegedabagacad
  118. alias ls="ls -G"
  119. fi
  120. # export GREP_OPTIONS=""
  121. alias gr="grep -n --color=always"
  122. iswindows && alias grep="grep -n"
  123. # alias ll="ls -l"
  124. # alias la="ls -A"
  125. # alias lla="ls -Al"
  126. alias less="less -F"
  127. null type emacs && alias em="emacs -nw"
  128. null type vim && alias vi=vim
  129. alias pstree="LANG=C pstree"
  130. alias cp="cp -v"
  131. alias mv="mv -v"
  132. alias rm="rm -v"
  133. alias psaux="ps auxww"
  134. alias q=exit
  135. null type e3em && alias e3=e3em
  136. #alias dirs="dirs -v -l | \grep -v \$(printf '%s$' \$PWD)"
  137. alias po=popd
  138. alias pu=pushd
  139. null type sudo && alias sudo="sudo " # use aliases through sudo
  140. null type sudoedit && alias sudoe="sudoedit"
  141. null type halt && alias halt="sudo halt"
  142. null type reboot && alias reboot="sudo reboot"
  143. null type dbus-send && {
  144. alias suspend="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  145. /org/freedesktop/UPower org.freedesktop.UPower.Suspend"
  146. alias hibernate="dbus-send --system --print-reply --dest=org.freedesktop.UPower \
  147. /org/freedesktop/UPower org.freedesktop.UPower.Hibernate"
  148. }
  149. alias rand="echo \$RANDOM"
  150. null type file-roller && alias xunp="file-roller -h"
  151. null type paco && alias pc="sudo \paco -D"
  152. alias pycalc="python -i -c 'from math import *' "
  153. null type python3 && alias py3=python3
  154. null type python2 && alias py2=python2
  155. alias _reloadrc="test -f ~/.bashrc && source ~/.bashrc"
  156. # alias mytime="date +%Y%m%d-%H%M%S"
  157. alias sh="ENV=$HOME/.shrc PS1=\$\ PROMPT_COMMAND="" sh"
  158. # type trash >/dev/null 2>&1 && alias rm=trash
  159. null type mpg123 && alias mpg123="mpg123 -C -v --title"
  160. null type xmms2 && alias xm="xmms2"
  161. #export PLAYER="mpg123 -C -v --title"
  162. null type screen && alias screen="screen -e^z^z"
  163. #alias zcd="cd \`zenity --file-selection --directory\`"
  164. null type gtags && alias gtags="gtags --verbose"
  165. null type htags && alias htags="htags --xhtml --symbol --line-number \
  166. --frame --alphabet --verbose"
  167. null type aunpack && alias aun=aunpack
  168. null type lv && alias lv="lv|less"
  169. isdarwin && alias updatedb="LC_ALL=C updatedb"
  170. # do not use locate installed by macports
  171. isdarwin && test -x /usr/bin/locate && alias locate="/usr/bin/locate"
  172. # pad
  173. alias pad=notepad
  174. null type gedit && alias pad=gedit
  175. null type leafpad && alias pad=leafpad
  176. isdarwin && alias pad="open -e"
  177. null type wicd-curses && alias wic=wicd-curses
  178. null type wicd-cli && alias wil="wicd-cli -y -l | head"
  179. #alias wicn="wicd-cli -y -c -n"
  180. wicn(){
  181. if test $# -eq 0
  182. then
  183. local num
  184. wicd-cli -y -l | head
  185. echo -n "input num: "
  186. read num
  187. test -n "$num" && wicd-cli -y -c -n $num
  188. else
  189. wicd-cli -y -c -n $1
  190. fi
  191. }
  192. for f in /usr/share/vim/vimcurrent/macros/less.sh \
  193. /usr/share/vim/vim73/macros/less.sh \
  194. /usr/share/vim/vim72/macros/less.sh
  195. do
  196. test -f $f && alias vl=$f && break
  197. done
  198. null type yaourt && alias yt=yaourt
  199. null type cower && alias cower="cower --color=auto"
  200. null type pacmatic && {
  201. alias pacman="pacmatic"
  202. export PACMAN="pacmatic"
  203. }
  204. null type apt-get && {
  205. alias aupgrade="sudo apt-get autoremove --yes && \
  206. sudo apt-get update --yes && sudo apt-get upgrade --yes"
  207. alias aptin="apt-get install"
  208. alias aptsearch="apt-cache search"
  209. alias aptshow="apt-cache show"
  210. }
  211. null type port && {
  212. alias port="port -v"
  213. alias pupgrade="sudo port -v selfupdate && \
  214. { sudo port -v upgrade outdated; }"
  215. }
  216. if iscygwin; then
  217. null type windate || \
  218. alias windate="/c/Windows/System32/cmd.exe //c 'echo %DATE%-%TIME%'"
  219. alias cygsu="cygstart /cygwinsetup.exe"
  220. alias emacs="CYGWIN=tty emacs -nw"
  221. alias ls="ls -CFG $(iswindows || test "$TERM" = dumb || echo --color=auto)"
  222. fi
  223. g(){
  224. if test $# -eq 0 && null type git-info
  225. then
  226. git info
  227. else
  228. git "$@"
  229. fi
  230. }
  231. if null type _git && inbash
  232. then
  233. # enable programmable completion for g
  234. complete -o bashdefault -o default -o nospace -F _git g 2>/dev/null \
  235. || complete -o default -o nospace -F _git g
  236. fi
  237. null type gitmemo && alias m=gitmemo
  238. null type gitmemo && alias m=gitmemo
  239. alias setup.py="sudo python3 setup.py install --record files.txt"
  240. ssh(){
  241. __my_set_screen_title ssh
  242. command ssh "$@"
  243. }
  244. clk(){
  245. local tformat="%Y/%m/%d %H:%M:%S %z"
  246. cal
  247. REPLY=
  248. printf "\\r`date "+${tformat}"`"
  249. read -t 1
  250. while test $? -ne 0
  251. do
  252. printf "\\r`date "+${tformat}"`"
  253. read -t 1
  254. done
  255. }
  256. man(){
  257. env \
  258. LESS_TERMCAP_mb=$(printf "\e[1;35m") \
  259. LESS_TERMCAP_md=$(printf "\e[1;31m") \
  260. LESS_TERMCAP_me=$(printf "\e[0m") \
  261. LESS_TERMCAP_se=$(printf "\e[0m") \
  262. LESS_TERMCAP_so=$(printf "\e[1;44;33m") \
  263. LESS_TERMCAP_ue=$(printf "\e[0m") \
  264. LESS_TERMCAP_us=$(printf "\e[1;32m") \
  265. man "$@"
  266. }
  267. scr(){
  268. test -n "$1" && pf="${1}-"
  269. local _tformat="%Y%m%d-%H%M%S%z"
  270. local _file="${HOME}/${pf}`date +${_tformat}`.script"
  271. SCRIPT=${_file} script ${_file} "$@"
  272. }
  273. netwait(){
  274. while ! ping -c 1 -t 1 example.com
  275. do
  276. true
  277. done
  278. echo network works.
  279. }
  280. cd(){
  281. if test $# -eq 0
  282. then
  283. pushd ~/ >/dev/null
  284. elif test "$1" = -
  285. then
  286. local pwd="$PWD"
  287. command cd "$OLDPWD"
  288. pushd -n "$pwd" >/dev/null # stack last dir
  289. elif ! test -d "$1"
  290. then
  291. echo `basename ${SHELL}`: cd: "$1": No such file or directory 1>&2
  292. return 1
  293. else
  294. pushd "$1" >/dev/null
  295. fi
  296. __dirs_rm_dup "$PWD"
  297. echo "$PWD"
  298. }
  299. __dirs_rm_dup(){
  300. for d in "$@"
  301. do
  302. local next="$(__realpath --strip "$d")"
  303. for l in $(\dirs -v -l | cut -d $'\n' -f 2- | \
  304. \grep -x " *[0-9]\+ \+${next}" | \grep -o "^ *[0-9]\+ " | tac)
  305. do
  306. popd +$l -n >/dev/null
  307. done
  308. done
  309. }
  310. __realpath(){
  311. if type realpath >/dev/null 2>&1
  312. then
  313. command realpath "$@"
  314. else
  315. while ! test -d $1
  316. do
  317. shift
  318. done
  319. local d="$OLDPWD"
  320. command cd "$1"
  321. echo "$PWD"
  322. command cd "$d"
  323. fi
  324. }
  325. dh(){
  326. if test $# -eq 0
  327. then
  328. dirs -v -l
  329. else
  330. local dir="$(dirs -v -l | \grep "^ *$1 \+" | sed "s/^ *[0-9]* *//g")"
  331. cd "$dir"
  332. fi
  333. }
  334. input(){
  335. local foo
  336. stty -echo
  337. read foo
  338. stty echo
  339. echo $foo
  340. }
  341. tmux(){
  342. if test $# -eq 0
  343. then
  344. (cd ~; command tmux start;)
  345. if command tmux has -t main
  346. then
  347. command tmux attach -t main
  348. else
  349. (cd ~; command tmux new -s main;)
  350. fi
  351. else
  352. command tmux "$@"
  353. fi
  354. }
  355. mcrypt-stream(){
  356. test $# -eq 2 || return 1
  357. case $1 in
  358. en)
  359. mcrypt --key $2 | base64 ;;
  360. de)
  361. base64 -d | mcrypt -d --key $2 ;;
  362. esac
  363. }
  364. gpg-stream(){
  365. test $# -eq 2 || return 1
  366. case $1 in
  367. en)
  368. gpg --passphrase $2 -c --batch |base64 ;;
  369. de)
  370. base64 -d|gpg --passphrase $2 -d --batch ;;
  371. esac
  372. }
  373. dgpg(){
  374. if test "$1" = help || test -z "$2"
  375. then
  376. echo "dgpg: dgpg <en|de> <src-suffix> [<dst-suffix>]" 1>&2
  377. return
  378. fi
  379. local srcs="$2"
  380. local dsts="$3"
  381. test -z "$dsts" && dsts="${srcs}.out"
  382. local pw
  383. echo -n "dgpg pw: "
  384. read -s pw
  385. echo ""
  386. test -z "$pw" && return 1
  387. for f in *${srcs}
  388. do
  389. local d="$(basename "$f" "${srcs}")${dsts}"
  390. echo -n "Processing $f to $d..."
  391. if test -d "$f"
  392. then
  393. echo "`printf 'failed (%s is directory)' $f`"
  394. elif test -f "$d"
  395. then
  396. echo "`printf 'failed (%s is already exists)' $d`"
  397. elif <"$f" gpg-stream $1 $pw >"$d" 2>/dev/null
  398. then
  399. echo "done"
  400. else
  401. echo "failed"
  402. test -f "$d" && rm "$d"
  403. fi
  404. done
  405. }
  406. alias enst="gpg-stream en"
  407. alias dest="gpg-stream de"
  408. showinfo(){
  409. echo "Japanese letters are 表示可能"
  410. __try_exec diskinfo
  411. ! isdarwin && test -n "${DISPLAY}" && {
  412. __try_exec xrandr | \grep --color=never ^Screen
  413. }
  414. iswindows || __try_exec finger $USER
  415. LANG=C __try_exec id
  416. __try_exec xset q
  417. }
  418. x(){
  419. if [[ -z $DISPLAY ]] && ! [[ -e /tmp/.X11-unix/X0 ]] && (( EUID )); then
  420. #mkdir -p ~/.my/log
  421. # nohup startx >~/.my/log/xorg.log 2>&1 &
  422. # exit
  423. exec startx
  424. else
  425. echo "X cant be started! Another X is already running?" 1>&2
  426. fi
  427. }
  428. bak(){
  429. for file in "$@"
  430. do
  431. cp -v ${file} ${file}.bak
  432. done
  433. }
  434. di(){
  435. if type colordiff >/dev/null 2>&1 && test $TERM != dumb
  436. then
  437. local diffcmd=colordiff
  438. else
  439. local diffcmd=diff
  440. fi
  441. ${diffcmd} -u "$@" | ${PAGER}
  442. }
  443. tb(){
  444. local tb="$HOME/.my/tb"
  445. mkdir -p "$tb"
  446. for file in "$@"
  447. do
  448. mv -t "$tb" "$file"
  449. done
  450. }
  451. mkcd(){
  452. if test -d "$1"
  453. then
  454. echo "Dir \"$1\" already exists."
  455. else
  456. mkdir -p "$1"
  457. echo "Dir \"$1\" created."
  458. fi
  459. cd "$1"
  460. }
  461. if test -n "$TMUX" && null type reattach-to-user-namespace
  462. then
  463. alias pbpaste="reattach-to-user-namespace pbpaste"
  464. alias pbcopy="reattach-to-user-namespace pbcopy"
  465. fi
  466. catclip(){
  467. if iswindows
  468. then
  469. cat /dev/clipboard | tr -d \\r
  470. elif isdarwin
  471. then
  472. pbpaste
  473. else
  474. xclip -o -selection "clipboard"
  475. fi
  476. }
  477. setclip(){
  478. if test $# -eq 0
  479. then
  480. exec 3<&0
  481. else
  482. exec 3<<__EOF__
  483. `cat "$@"`
  484. __EOF__
  485. fi
  486. if iswindows
  487. then
  488. 0<&3 sed -e 's/$/\r/' | tee /dev/clipboard
  489. elif isdarwin
  490. then
  491. pbcopy 0<&3
  492. else
  493. 0<&3 xclip -i -f -selection "primary" | \
  494. xclip -i -f -selection "clipboard"
  495. fi
  496. exec 3<&-
  497. }
  498. open_file(){
  499. if iswindows
  500. then
  501. cmd.exe //c start "" "$@"
  502. elif isdarwin
  503. then
  504. touch "$@"
  505. open "$@"
  506. elif islinux
  507. then
  508. touch "$@"
  509. if null type pcmanfm; then
  510. LC_MESSAGES= pcmanfm "$@"
  511. else
  512. LC_MESSAGES= xdg-open "$@" &
  513. fi
  514. else
  515. cat "$@"
  516. fi
  517. }
  518. o(){
  519. if test $# -eq 0
  520. then
  521. open_file .
  522. else
  523. for f in "$@"
  524. do
  525. open_file "$(realpath "$f")"
  526. done
  527. fi
  528. }
  529. convmv-sjis2utf8-test(){
  530. convmv -r -f sjis -t utf8 *
  531. }
  532. convmv-sjis2utf8-notest(){
  533. convmv -r -f sjis -t utf8 * --notest
  534. }
  535. winln(){
  536. # for windose make link (actually junction)
  537. if test $# -eq 0
  538. then
  539. {
  540. echo "usage: winln TARGET LINK_NAME"
  541. echo "Create a link to TARGET with the name LINK_NAME \
  542. (that is, TARGET must already exist)."
  543. echo "About other features run 'junction'."
  544. } 1>&2
  545. return 1
  546. else
  547. junction "$2" "$1"
  548. fi
  549. }
  550. __my_moc_state(){
  551. type mocp >/dev/null 2>&1 || return
  552. test "`mocp -Q %state 2>/dev/null`" = PLAY || return
  553. printf "$1" "`mocp -Q %title 2>/dev/null`"
  554. }
  555. __my_parse_svn_branch() {
  556. local LANG=C
  557. local svn_url=$(svn info 2>/dev/null | sed -ne 's#^URL: ##p')
  558. local svn_repository_root=$(svn info 2>/dev/null | \
  559. sed -ne 's#^Repository Root: ##p')
  560. echo ${svn_url} | sed -e 's#^'"${svn_repository_root}"'##g' | \
  561. awk '{print $1}'
  562. }
  563. __my_svn_ps1(){
  564. if svn status >/dev/null 2>&1
  565. then
  566. local svn_branch=$(__my_parse_svn_branch)
  567. test -n "${svn_branch}" && printf "$1" "{$svn_branch}"
  568. fi
  569. }
  570. __my_battery_status(){
  571. local dir=/sys/class/power_supply/BAT0
  572. if test -d $dir && test -r $dir/status && test -r $dir/charge_full && \
  573. test -r $dir/charge_now
  574. then
  575. local st=$(cat $dir/status)
  576. local full=$(cat $dir/charge_full)
  577. local now=$(cat $dir/charge_now)
  578. local rate=$(expr $now \* 100 / $full)
  579. printf "$1" "${st}:${rate}%"
  580. fi
  581. }
  582. alias bat='__my_battery_status %s\\n'
  583. ip-address(){
  584. type ip >/dev/null 2>&1 || return 1
  585. local ip=$(LANG=C ip addr show scope global | \
  586. \grep --color=never --only-matching 'inet [^ ]*' | cut -d " " -f 2)
  587. test -n "$ip" && printf $1 $ip
  588. }
  589. __my_ps1_script(){
  590. local last=$?
  591. test -n "$SCRIPT" && echo "${__my_c5}SCR${__my_cdef} "
  592. return $last
  593. }
  594. __my_ps1_scale(){
  595. local last=$?
  596. printf "${LINES}x${COLUMNS}"
  597. return $last
  598. }
  599. __my_ps1_tmux(){
  600. local last=$?
  601. null type tmux || return $last
  602. local tmuxc="$(tmux display -p '#S:#I:#W.#P' 2>/dev/null)"
  603. test -n "$TMUX" && echo "[TMUX:$tmuxc]"
  604. return $last
  605. }
  606. __my_ps1_moc(){
  607. local last=$?
  608. __my_moc_state "[MOC:%s]"
  609. return $last
  610. }
  611. for f in /usr/share/git/git-prompt.sh \
  612. /opt/local/share/git-core/git-prompt.sh \
  613. /opt/local/share/doc/git-core/contrib/completion/git-prompt.sh
  614. do
  615. test -r $f && . $f && break
  616. done
  617. GIT_PS1_SHOWDIRTYSTATE=t
  618. GIT_PS1_SHOWUPSTREAM=t
  619. __my_ps1_git(){
  620. local last=$?
  621. null type __git_ps1 || return $last
  622. null __gitdir || return $last
  623. __git_ps1 "[GIT:$(__try_exec git config --get user.name):%s]"
  624. return $last
  625. }
  626. __my_ps1_ipaddr(){
  627. local last=$?
  628. ! iswindows && ip-address [Addr:%s]
  629. return $last
  630. }
  631. __my_ps1_bttry(){
  632. local last=$?
  633. local bst="${TMP}/batterystatus"
  634. if test -z "$DISPLAY" && ! iswindows
  635. then
  636. test -f $bst && local bstr="$(cat $bst)"
  637. test -n "$bstr" && ! echo $bstr | grep 100 >/dev/null 2>&1 && \
  638. echo "[Battery:$bstr]"
  639. __my_battery_status %s >$bst &
  640. fi
  641. return $last
  642. }
  643. __my_ps1_dirs(){
  644. dirs | wc -l
  645. }
  646. __my_ps1_jobs(){
  647. jobs | wc -l
  648. }
  649. if test "$TERM" != dumb
  650. then
  651. __my_c1="\[\e[0;33m\]" # color for PWD
  652. __my_c2="\[\e[0;36m\]" # color for user
  653. __my_c3="\[\e[1;30m\]" # color for OLDPWD
  654. if test "`hostname`" = arch-aspireone; then __my_c4="\[\e[1;34m\]"
  655. elif test "`hostname`" = darwin-mba.local; then __my_c4="\[\e[1;31m\]"
  656. elif test "`hostname`" = newkiwi; then __my_c4="\[\e[1;35m\]"
  657. else __my_c4="\[\e[1;32m\]" # color for ::
  658. fi
  659. __my_c5="\[\e[30;47m\]" # color for SCR
  660. __my_cdef="\[\e[0m\]"
  661. fi
  662. export _LAST_STATUS=$?
  663. __my_export_last_status(){
  664. export _LAST_STATUS=$?
  665. echo $_LAST_STATUS
  666. return $_LAST_STATUS
  667. }
  668. _ps1_bash="\
  669. ${__my_c4}:: ${__my_cdef}[${__my_c2}\u@\H${__my_cdef}:${__my_c1}\w/${__my_cdef}]\$(__my_ps1_git)\$(__my_ps1_bttry)\$(__my_ps1_ipaddr)\$(__my_ps1_moc)\n\
  670. ${__my_c4}:: ${__my_cdef}l${SHLVL}n\#j\js\$? $(__my_ps1_scale) \D{%T} $(__my_ps1_script)\$ "
  671. inbash && PS1=$_ps1_bash
  672. __my_set_screen_title(){
  673. if test -n "$TMUX" && test -z "$INSIDE_EMACS"
  674. then
  675. echo -ne "\033k$1\033\\"
  676. fi
  677. }
  678. __my_set_title(){
  679. case $TERM in
  680. (rxvt*|xterm*|aterm|screen*)
  681. title="$(echo $@)"
  682. test -t 1 &&
  683. test -n "$DISPLAY" &&
  684. test -z "$EMACS" &&
  685. echo -n -e "\033]0;${title}\007"
  686. ;;
  687. esac
  688. }
  689. PROMPT_COMMAND="__my_set_title \${USER}@\${HOSTNAME}\:\${PWD};
  690. __my_set_screen_title \$(basename \"\$PWD\")/"